package de.lmu.ifi.pst.viewcontroller;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextArea;
import javax.swing.JTextField;

public abstract class AbstractPanel extends JPanel {

	protected ExternalFrame frame;

	protected JPanel topPanel;
	protected JLabel topLeftLabel;
	protected JLabel topRightLabel;

	protected JPanel centerPanel;
	protected JTextArea leftCenterTextArea;
	protected JPanel rightCenterContainer;
	protected JButton firstButton;
	protected JPanel firstButtonPanel;
	protected JButton secondButton;
	protected JPanel secondButtonPanel;
	protected JTextField textfield;

	public AbstractPanel(ExternalFrame frame) {
		this.frame = frame;
		this.setLayout(new BorderLayout());
		
		addComponents();

		this.firstButton.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				firstButtonOnClick();
			}
		});

		this.secondButton.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				secondButtonOnClick();
			}

		});

		this.add(topPanel, BorderLayout.PAGE_START);
		this.add(centerPanel);
	}

	protected abstract void secondButtonOnClick();

	protected abstract void firstButtonOnClick();

	protected void setTopLeftLabel() {
		this.topLeftLabel.setText("Mitarbeiter in Schicht " + (frame.model.getIndex() + 1));
	}

	protected void setFirstButtonText(String s) {
		this.firstButton.setText(s);
	}

	protected void setSecondButtonText(String s) {
		this.secondButton.setText(s);
	}
	
	private void addComponents() {
		this.topPanel = new JPanel(new GridLayout(1, 2));
		this.topPanel.setMinimumSize(new Dimension(600, 100));

		this.topLeftLabel = new JLabel("Mitarbeiter in Schicht " + (this.frame.model.getIndex() + 1));
		this.topLeftLabel.setBorder(BorderFactory.createLineBorder(Color.BLACK));
		this.topRightLabel = new JLabel("");
		this.topPanel.add(topLeftLabel);
		this.topPanel.add(topRightLabel);

		this.centerPanel = new JPanel(new GridLayout(1, 2));

		this.leftCenterTextArea = new JTextArea("Fge Mitarbeiter hinzu");
		this.leftCenterTextArea.setEditable(false);
		this.leftCenterTextArea.setBorder(BorderFactory.createLineBorder(Color.BLACK));

		this.rightCenterContainer = new JPanel(new GridLayout(2, 1));
		this.firstButton = new JButton();
		this.firstButtonPanel = new JPanel(new GridLayout(3, 1));
		this.textfield = new JTextField();
		this.firstButtonPanel.add(textfield);
		this.firstButtonPanel.add(new JPanel());
		this.firstButtonPanel.add(this.firstButton);
		this.rightCenterContainer.add(this.firstButtonPanel);
		this.secondButtonPanel = new JPanel(new GridLayout(3, 1));
		this.secondButton = new JButton();
		this.secondButtonPanel.add(new JPanel());
		this.secondButtonPanel.add(this.secondButton);
		this.rightCenterContainer.add(this.secondButtonPanel);

		this.centerPanel.add(leftCenterTextArea);
		this.centerPanel.add(rightCenterContainer);
	}

}
